#!/system/bin/sh

LOGFILE=/data/local/tmp/cwm-install.log

ECHOL(){
  _DATETIME=`date +"%Y%m%d %H%M%S"`
  echo "${_DATETIME}: $*" >> ${LOGFILE}
  return 0
}
EXECL(){
  _DATETIME=`date +"%Y%m%d %H%M%S"`
  echo "${_DATETIME}: $*" >> ${LOGFILE}
  $* 2>> ${LOGFILE}
  _RET=$?
  echo "${_DATETIME}: RET=${_RET}" >> ${LOGFILE}
  return ${_RET}
}

if [ -e "${LOGFILE}" ]; then
  rm ${LOGFILE}
fi
touch ${LOGFILE}

if [ "`getprop init.svc.ric`" = "running" ]; then
  EXECL stop ric
fi
EXECL busybox mount -o remount,rw /system
if [ $? -ne 0 ]; then
  exit 1
fi

CHARGEMON=/system/bin/chargemon
CHARGER=/system/bin/charger
RECOVERYTAR=/system/bin/recovery.tar

# /system/btmgr
EXECL busybox mkdir -p /system/btmgr/bin
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chown root.shell /system/btmgr
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chmod 755 /system/btmgr
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chown root.shell /system/btmgr/bin
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chmod 755 /system/btmgr/bin
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL cp /data/local/tmp/busybox /system/btmgr/bin/busybox
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chown root.shell /system/btmgr/bin/busybox
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chmod 755 /system/btmgr/bin/busybox
if [ $? -ne 0 ]; then
  exit 1
fi

# for /system/bin/charger
if [ "`dd bs=1 count=3 if=${CHARGEMON} skip=1`" = "ELF" ]; then
  EXECL cp -p ${CHARGEMON} ${CHARGEMON}.bin.org
  if [ $? -ne 0 ]; then
    exit 1
  fi
  EXECL cp -p ${CHARGEMON} ${CHARGER}
  if [ $? -ne 0 ]; then
    exit 1
  fi
elif [ -e "${CHARGEMON}.bin.org" -a "`dd bs=1 count=3 if=${CHARGEMON}.bin.org skip=1`" = "ELF" ]; then
  EXECL cp -p ${CHARGEMON}.bin.org ${CHARGER}
  if [ $? -ne 0 ]; then
    exit 1
  fi
elif [ -e "${CHARGEMON}.stock" -a "`dd bs=1 count=3 if=${CHARGEMON}.stock skip=1`" = "ELF" ]; then
  EXECL cp -p ${CHARGEMON}.stock ${CHARGER}
  if [ $? -ne 0 ]; then
    exit 1
  fi
elif [ -e "${CHARGEMON}.org" -a "`dd bs=1 count=3 if=${CHARGEMON}.org skip=1`" = "ELF" ]; then
  EXECL cp -p ${CHARGEMON}.org ${CHARGER}
  if [ $? -ne 0 ]; then
    exit 1
  fi
fi

# /system/bin/chargemon
EXECL cp /data/local/tmp/chargemon ${CHARGEMON}
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chown root.shell ${CHARGEMON}
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chmod 755 ${CHARGEMON}
if [ $? -ne 0 ]; then
  exit 1
fi

# /system/bin/recovery.tar
EXECL cp /data/local/tmp/recovery.tar  ${RECOVERYTAR}
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chown root.shell ${RECOVERYTAR}
if [ $? -ne 0 ]; then
  exit 1
fi
EXECL chmod 644 ${RECOVERYTAR}
if [ $? -ne 0 ]; then
  exit 1
fi

echo "SUCCESS"
exit 0
